#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <sys\timeb.h>
#include <dos.h>
#include "winsock.h"

#include "settings.h"

#define LOST		20
#define DUPL		20		// LOST + DUPL < 100 !!!

FILE *out;
WSADATA wsaData;
SOCKET RecvSocket;
sockaddr_in RecvAddr;
sockaddr_in SendAddr;
int SendAddrSize = sizeof(SendAddr);
char RecvBuf[WINDOW][BUFFSIZE+1];
int good[WINDOW] = {0,0,0,0};
int last_packet = -1;
int ending = BUFFLENGTH + 1;
bool ack = false;
bool done = false;

int mod(int x, int M) {
	int y = x % M;
   if(y < 0)
   	return y + M;
  	return y;
}

void mysend(int i) {
	int err;
	char buf[BUFFSIZE];
   buf[0] = i;
   buf[1] = 0;
   int rnd = rand() % 100;
   if(rnd < LOST) {
   	printf("Losing acknowledge %d\n", i);
   }
   else if(rnd < (DUPL + LOST)) {
   	printf("Duplicating acknowledge %d\n", i);
		if((err = sendto(RecvSocket, buf, BUFFSIZE, 0, (SOCKADDR *) &SendAddr, sizeof(SendAddr))) == SOCKET_ERROR){
			printf( "sendto() failed. %d\n", WSAGetLastError() );
			WSACleanup();
			getch();
   	   exit(1);
	   }
		if((err = sendto(RecvSocket, buf, BUFFSIZE, 0, (SOCKADDR *) &SendAddr, sizeof(SendAddr))) == SOCKET_ERROR){
			printf( "sendto() failed. %d\n", WSAGetLastError() );
			WSACleanup();
			getch();
   	   exit(1);
	   }
   }
   else {
	   printf("Sending acknowledge %d\n", i);
		if((err = sendto(RecvSocket, buf, BUFFSIZE, 0, (SOCKADDR *) &SendAddr, sizeof(SendAddr))) == SOCKET_ERROR){
			printf( "sendto() failed. %d\n", WSAGetLastError() );
			WSACleanup();
			getch();
   	   exit(1);
	   }
   }
}

void savetofile() {
	int i, cnt = -1;
	for(i = 0; i < WINDOW; i++) {
   	if(good[i] > 0)
      	cnt = i;
      else
      	break;
   }
   for(i = 0; i <= cnt; i++) {
   	int num = fwrite(RecvBuf[i], 1, good[i], out);
   	if(num != good[i]) {
      	printf("writed %d bytes from %d!!!\n", num, good[i]);
         sleep(5);
      }
   }
   if((cnt > -1) || done) {
	   for(i = 0; i < WINDOW; i++) {
      	if((i + cnt + 1) < WINDOW) {
         	strcpy(RecvBuf[i],RecvBuf[i+cnt+1]);
            good[i] = good[i+cnt+1];
         }
         else
            good[i] = 0;
   	}

      if(last_packet == (ending -1))
      	last_packet = ending;
	   last_packet = mod(last_packet + cnt + 1, BUFFLENGTH);
	   mysend(last_packet);
      fflush(out);
	}
}

int main(int argc, char * argv[]) {
	char buf[BUFFSIZE + 2] = "";
   timeval t;
   t.tv_sec = t.tv_usec = 0;
   int i, ll;

   if((out = fopen("rcv.txt", "wb")) == NULL) {
      printf("Cannot open output file.\n");
      getch();
      return 1;
   }

	//---------------------------------------------
	// Initialize Winsock
	int iResult = WSAStartup( MAKEWORD(2,2), &wsaData );
	if(iResult != NO_ERROR) {
		printf("Error at WSAStartup()\n");
		getch();
		exit(1);
	}

	//---------------------------------------------
	// Create a socket for sending data
	RecvSocket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);

	if(RecvSocket == INVALID_SOCKET) {
		printf( "Error at socket(): %ld\n", WSAGetLastError() );
		WSACleanup();
		getch();
      exit(1);
	}

	RecvAddr.sin_family = AF_INET;
   RecvAddr.sin_port = htons(ECHOPORT);
	RecvAddr.sin_addr.s_addr = htonl(INADDR_ANY);

	if (bind(RecvSocket, (SOCKADDR *) &RecvAddr, sizeof(RecvAddr)) == SOCKET_ERROR ) {
		printf( "bind() failed.\n" );
		closesocket(RecvSocket);
		WSACleanup();
		getch();
      exit(1);
	}

   randomize();

   printf("Server waiting for data...\n\n");

	while(!done || !ack) {
   	int err;

     	int num = 0;
      int length = 0;
      while(num != BUFFSIZE + 2) {
		   fd_set rset;
		   FD_ZERO(&rset);
		   FD_SET(RecvSocket, &rset);

		   if((err = select(0, &rset, NULL, NULL, &t)) == SOCKET_ERROR) {
		   	printf("error in select(): %d\n", WSAGetLastError());
		      getch();
		      exit(1);
		   }
		   else if(err != 0) {
		   	if((err = recvfrom(RecvSocket, buf + num, BUFFSIZE + 2 - num, 0, (SOCKADDR *)&SendAddr, &SendAddrSize)) == SOCKET_ERROR) {
 					printf("Connection closed: %d\n", WSAGetLastError());
      	      done = 1;
     	   	   break;
	        	}
		      else if(err != 0) {
	   	      num += err;
         	   if(length == 0)
     	      		length = byte(buf[0]) + 2;
	        	   if(num >= length)
   	        		break;
      	   }
         	else {
         		printf("???\n");
	         	done = 1;
   	         break;
      	   }
         }
         else if(ll < BUFFSIZE + 2) {
         	printf("Ending without finishing packet\n");
         	done = true;
            ack = true;
         }
		}
   	int new_packet = byte(buf[1]);
   	if((mod(new_packet - last_packet - 1, BUFFSIZE) < WINDOW)) {
      	i = mod(new_packet - last_packet - 1, WINDOW);
         if(length != 2)
		      printf("Get packet: %d of size %d\n", new_packet, length);
         else
		      printf("Get finishing packet\n");
      	good[i] = length - 2;
  	     	memcpy(RecvBuf[i], buf + 2, length - 2);
         if(length == 2) {
      	  	done = true;
            ending = new_packet;
         }
  		   savetofile();
         ll = length;
      }
      else if(new_packet == last_packet)
		   mysend(last_packet);
      if(last_packet >= ending)
      	ack = true;
   }

   printf("\n\nFinished. Closing socket.\n");
   fclose(out);
   closesocket(RecvSocket);
   WSACleanup();
   getch();
   printf("Done...\n");
   return 0;
}
